Synnefo - Bug # 905

Status: Closed Priority: High

Author: Vangelis Koukis Category: Cyclades Ul
Created: 07/21/2011 Assignee: Kostas Papadimitriou
Updated: 07/27/2011 Due date:

Subject: Javascript throws exception when left idle

Description

Feedback message:

Error report

Code: -5

Type: Ul Error

Action: Update VMs

Data: [Exception... "Component returned failure code: 0x80040111 (NS_ERROR_NOT_AVAILABLE) [nsIXMLHttpRequest.status]"
nsresult: "0x80040111 (NS_ERROR_NOT_AVAILABLE)" location: "JS frame :: https://okeanos.grnet.gr/static/synnefo.js ::
<TOP_LEVEL> :: line 375" data: no]

Please describe the actions that triggered the error:

browser left inactive, after minutes of inactivity, this error came up.

User accepted data send:
True

User info:
ID: 51
Email: nkoziris@cslab.ece.ntua.gr

User application
data:{"servers"{"0":{"status":"ACTIVE","updated":"2011-07-19T719:31:31+00:00","hostld":"","addresses":{"values":[{"firewallProfile":"DISAB
BLED

" "mac":"aa:0c:ea:0c:b5:30","values":[{"version":4,"addr":"62.217.112.15"},{"version":6,"addr":"2001:648:2ffc:1112:a80c:eaff:fe0c:0530"
}1,"id":"public","name":"public"}]},"name":"kubuntu","imageRef":4,"created":"2011-07-19T18:31:43+00:00","flavorRef":1,"progress":100,"i
d":19,"metadata":{"values":{"OS":"kubuntu"}}},"1":{"status":"ACTIVE","updated":"2011-07-19T22:36:05+00:00","hostId":"","addresses":{"va

+lues":[{"firewallProfile":"DISABLED","mac":"aa:0c:ea:52:11:cc","values":[{"version":4,"addr":"62.217.112.24"} ,{"version":6,"addr":"2001
:648:2ffc:1112:a80c:eaff:fe52:11cc"}],"id":"public","name":"public"}]},"name":"stargate-4","imageRef":7,"created":"2011-07-19T722:16:51+
00:00","flavorRef":1,"progress":100,"id":43,"metadata":{"values":{"OS":"windows"}}},"2":{"status":"ACTIVE","updated":"2011-07-20T18:2

+01+00:00","hostld":"","addresses":{"values":[{"firewallProfile":"DISABLED","m
ac":"aa:0c:ea:79:37:ed","values":[{"version":4,"addr":"62.217.112.52"} {"version":6,"addr":"2001:648:2ffc:1112:a80c:eaff:fe79:37ed"}],"i
+d":"public","name":"public"}]},"name":"stargate-5","imageRef":7,"created":"2011-07-20T12:53:03+00:00","flavorRef":1,"progress":100,"i

:100,"metadata":{"values":{"OS":"windows"}}}},"client":{"browser":{"mozilla":true,"version":"5.0.1"},"screen™:{"top":176,"height": 1024,
"width":1280,"left";1920,"pixelDepth":24,"colorDepth":24,"availWidth":1280,"availHeight":990,"availLeft":1920,"avail Top":176},"client":
{"os™:"Windows","browser":"Firefox"}},"dates":{"now":"2011-07-20T 19:43:49.660Z","lastUpdate":"2011-07-20T 19:04:02.000Z2"}}
https://okeanos.grnet.gr/static/synnefo.js
mailto:nkoziris@cslab.ece.ntua.gr

Improve Ul exception handling, Refs #905
- Different error codes for different ui errors

- Don't block interaction for specific DOM exceptions (invalid xhr state)

- Append last ajax request information when reporting an error

History

#1 - 07/21/2011 06:35 pm - Vangelis Koukis

I think this is more of the same:

Feedback message:

Error report

Code: -5

Type: Ul Error

Action: Update VMs

Data: [Exception... "Component returned failure code: 0x80040111 (NS_ERROR_NOT_AVAILABLE) [nsIXMLHttpRequest.status]"
+nsresult: "0x80040111 (NS_ERROR_NOT_AVAILABLE)" location: "JS frame :: https://okeanos.grnet.gr/static/synnefo.js ::

+anonymous :: line 375" data: no]

Please describe the actions that triggered the error:

Elxa avotytd To ui, Eexaopgvo oe €va tab

User accepted data send:
True

User info:

#2 - 07/21/2011 07:19 pm - Kostas Papadimitriou

Its hard to reproduce but it seems that jquery sometimes executes error callbacks while browser xhr object is in invalid state.

The error seems to get triggered when trying to access the status attribute of that xhr object which follows to the Ul error.

Workaround

Since the error happens on scattered ajax calls, the Ul should not block user interaction for those specific exceptions.

#3 - 07/22/2011 12:24 pm - Kostas Papadimitriou

workaround + improvements for better user information reporting committed on

commit:7991d0c

#4 - 07/22/2011 02:27 pm - Kostas Papadimitriou

- Status changed from Assigned to Feedback

#5 - 07/25/2011 07:10 pm - Kostas Papadimitriou

commit:e5e5d5¢
https://okeanos.grnet.gr/static/synnefo.js

improved ajax calls exceptions handling.

Jquery provides textStatus of the error occured even for errors that provide invalid xhr objects.

Ul now fallbacks to error overlay, displaying textStatus content.

thanks to vkoukis for identifying that the “timeout errors™ caused xhr object to be left in invalid state.

#6 - 07/27/2011 05:42 pm - Vangelis Koukis
- Status changed from Feedback to Closed

This seems to be working properly, will be reopen if we encounter something similar in the future.
